package com.hw.wms.domain;

import java.math.BigDecimal;
import java.util.List;
import java.util.Date;

import com.fasterxml.jackson.annotation.JsonFormat;
import org.apache.commons.lang3.builder.ToStringBuilder;
import org.apache.commons.lang3.builder.ToStringStyle;
import com.hw.common.core.annotation.Excel;
import com.hw.common.core.web.domain.BaseEntity;

/**
 * 成品出库记录对象 wms_product_outstock
 *
 * @author xs
 * @date 2023-12-20
 */
public class WmsProductOutstock extends BaseEntity {
    private static final long serialVersionUID = 1L;

    /** 成品出库记录ID */
    private Long productOutstockId;

    /** 任务编号 */
    @Excel(name = "任务编号")
    private String taskCode;

    /** 仓库ID;领料时需要保存 */
    @Excel(name = "仓库ID;领料时需要保存")
    private Long warehouseId;

    /** 库位编码 */
    @Excel(name = "库位编码")
    private String locationCode;

    /** 成品类型（2半成品,3成品） */
    @Excel(name = "成品类型", readConverterExp = "2=半成品,3成品")
    private String productType;

    /** 操作类型(0自动,1人工,2强制,3调度) */
    @Excel(name = "操作类型(0自动,1人工,2强制,3调度)")
    private String operationType;

    /** 出库类型(1销售出库 9其他出库) */
    @Excel(name = "出库类型(1销售出库 9其他出库)")
    private String outstockType;

    /** 计划编号,关联pd_base_plan_info的plan_code */
    @Excel(name = "计划编号,关联pd_base_plan_info的plan_code")
    private String planCode;

    /** 计划明细编号,关联pd_base_plan_detail的plan_detail_code */
    @Excel(name = "计划明细编号,关联pd_base_plan_detail的plan_detail_code")
    private String planDetailCode;

    /** 销售订单ID主键 */
    @Excel(name = "销售订单ID主键")
    private Long saleOrderId;

    /** 销售订单编号 */
    @Excel(name = "销售订单编号")
    private String saleorderCode;

    /** 项目号 */
    @Excel(name = "项目号")
    private String projectNo;

    /** 成品ID，关联物料信息主键 */
    @Excel(name = "成品ID，关联物料信息主键")
    private Long productId;

    /** 成品批次 */
    @Excel(name = "成品批次")
    private String productBatch;

    /** 托盘RFID代码 */
    @Excel(name = "托盘RFID代码")
    private String palletInfoCode;

    /** 出库目的地 */
    @Excel(name = "出库目的地")
    private String endStationCode;

    /** 申请数量 */
    @Excel(name = "申请数量")
    private BigDecimal applyQty;

    /** 已出数量 */
    @Excel(name = "已出数量")
    private BigDecimal outstockQty;

    /** 申请原因 */
    @Excel(name = "申请原因")
    private String applyReason;

    /** 审核原因 */
    @Excel(name = "审核原因")
    private String auditReason;

    /** 审核状态(0待审核,1审核通过,2审核未通过) */
    @Excel(name = "审核状态(0待审核,1审核通过,2审核未通过)")
    private String auditStatus;

    /** 执行状态(0待执行,1执行中,2执行完成) */
    @Excel(name = "执行状态(0待执行,1执行中,2执行完成)")
    private String executeStatus;

    /** 申请人 */
    @Excel(name = "申请人")
    private String applyBy;

    /** 申请时间 */
    @JsonFormat(pattern = "yyyy-MM-dd")
    @Excel(name = "申请时间", width = 30, dateFormat = "yyyy-MM-dd")
    private Date applyDate;

    /** 审核人 */
    @Excel(name = "审核人")
    private String auditBy;

    /** 审核时间 */
    @JsonFormat(pattern = "yyyy-MM-dd")
    @Excel(name = "审核时间", width = 30, dateFormat = "yyyy-MM-dd")
    private Date auditDate;

    /** 最后更新时间 */
    @JsonFormat(pattern = "yyyy-MM-dd")
    @Excel(name = "最后更新时间", width = 30, dateFormat = "yyyy-MM-dd")
    private Date updateDate;

    /** 执行开始时间 */
    @JsonFormat(pattern = "yyyy-MM-dd")
    @Excel(name = "执行开始时间", width = 30, dateFormat = "yyyy-MM-dd")
    private Date beginTime;

    /** 执行结束时间 */
    @JsonFormat(pattern = "yyyy-MM-dd")
    @Excel(name = "执行结束时间", width = 30, dateFormat = "yyyy-MM-dd")
    private Date endTime;

    /** 同步ERP状态(0:失败,1成功) */
    @Excel(name = "同步ERP状态(0:失败,1成功)")
    private String erpStatus;

    /** 同步给ERP的数量 */
    @Excel(name = "同步给ERP的数量")
    private BigDecimal erpAmount;

    private String warehouseName;

    private String materialCode;

    private String materialName;




    /**
     * 成品出库记录明细信息
     */
    private List<WmsProductOutstockDetail> wmsProductOutstockDetailList;

    public void setProductOutstockId(Long productOutstockId) {
        this.productOutstockId = productOutstockId;
    }

    public Long getProductOutstockId() {
        return productOutstockId;
    }

    public void setTaskCode(String taskCode) {
        this.taskCode = taskCode;
    }

    public String getTaskCode() {
        return taskCode;
    }

    public void setWarehouseId(Long warehouseId) {
        this.warehouseId = warehouseId;
    }

    public Long getWarehouseId() {
        return warehouseId;
    }

    public void setLocationCode(String locationCode) {
        this.locationCode = locationCode;
    }

    public String getLocationCode() {
        return locationCode;
    }

    public String getProductType() {
        return productType;
    }

    public void setProductType(String productType) {
        this.productType = productType;
    }

    public void setOperationType(String operationType) {
        this.operationType = operationType;
    }

    public String getOperationType() {
        return operationType;
    }

    public void setOutstockType(String outstockType) {
        this.outstockType = outstockType;
    }

    public String getOutstockType() {
        return outstockType;
    }

    public String getPlanCode() {
        return planCode;
    }

    public void setPlanCode(String planCode) {
        this.planCode = planCode;
    }

    public String getPlanDetailCode() {
        return planDetailCode;
    }

    public void setPlanDetailCode(String planDetailCode) {
        this.planDetailCode = planDetailCode;
    }

    public Long getSaleOrderId() {
        return saleOrderId;
    }

    public void setSaleOrderId(Long saleOrderId) {
        this.saleOrderId = saleOrderId;
    }

    public String getSaleorderCode() {
        return saleorderCode;
    }

    public void setSaleorderCode(String saleorderCode) {
        this.saleorderCode = saleorderCode;
    }

    public String getProjectNo() {
        return projectNo;
    }

    public void setProjectNo(String projectNo) {
        this.projectNo = projectNo;
    }

    public Long getProductId() {
        return productId;
    }

    public void setProductId(Long productId) {
        this.productId = productId;
    }

    public BigDecimal getApplyQty() {
        return applyQty;
    }

    public void setApplyQty(BigDecimal applyQty) {
        this.applyQty = applyQty;
    }

    public BigDecimal getOutstockQty() {
        return outstockQty;
    }

    public void setOutstockQty(BigDecimal outstockQty) {
        this.outstockQty = outstockQty;
    }

    public void setApplyReason(String applyReason) {
        this.applyReason = applyReason;
    }

    public String getApplyReason() {
        return applyReason;
    }

    public void setAuditReason(String auditReason) {
        this.auditReason = auditReason;
    }

    public String getAuditReason() {
        return auditReason;
    }

    public void setAuditStatus(String auditStatus) {
        this.auditStatus = auditStatus;
    }

    public String getAuditStatus() {
        return auditStatus;
    }

    public void setExecuteStatus(String executeStatus) {
        this.executeStatus = executeStatus;
    }

    public String getExecuteStatus() {
        return executeStatus;
    }

    public void setApplyBy(String applyBy) {
        this.applyBy = applyBy;
    }

    public String getApplyBy() {
        return applyBy;
    }

    public void setApplyDate(Date applyDate) {
        this.applyDate = applyDate;
    }

    public Date getApplyDate() {
        return applyDate;
    }

    public void setAuditBy(String auditBy) {
        this.auditBy = auditBy;
    }

    public String getAuditBy() {
        return auditBy;
    }

    public void setAuditDate(Date auditDate) {
        this.auditDate = auditDate;
    }

    public Date getAuditDate() {
        return auditDate;
    }

    public void setUpdateDate(Date updateDate) {
        this.updateDate = updateDate;
    }

    public Date getUpdateDate() {
        return updateDate;
    }

    public void setBeginTime(Date beginTime) {
        this.beginTime = beginTime;
    }

    public Date getBeginTime() {
        return beginTime;
    }

    public void setEndTime(Date endTime) {
        this.endTime = endTime;
    }

    public Date getEndTime() {
        return endTime;
    }

    public String getErpStatus() {
        return erpStatus;
    }

    public void setErpStatus(String erpStatus) {
        this.erpStatus = erpStatus;
    }

    public BigDecimal getErpAmount() {
        return erpAmount;
    }

    public void setErpAmount(BigDecimal erpAmount) {
        this.erpAmount = erpAmount;
    }

    public String getProductBatch() {
        return productBatch;
    }

    public void setProductBatch(String productBatch) {
        this.productBatch = productBatch;
    }

    public String getPalletInfoCode() {
        return palletInfoCode;
    }

    public void setPalletInfoCode(String palletInfoCode) {
        this.palletInfoCode = palletInfoCode;
    }

    public String getEndStationCode() {
        return endStationCode;
    }

    public void setEndStationCode(String endStationCode) {
        this.endStationCode = endStationCode;
    }

    public List<WmsProductOutstockDetail> getWmsProductOutstockDetailList() {
        return wmsProductOutstockDetailList;
    }

    public void setWmsProductOutstockDetailList(List<WmsProductOutstockDetail> wmsProductOutstockDetailList) {
        this.wmsProductOutstockDetailList = wmsProductOutstockDetailList;
    }

    public String getWarehouseName() {
        return warehouseName;
    }

    public void setWarehouseName(String warehouseName) {
        this.warehouseName = warehouseName;
    }

    public String getMaterialCode() {
        return materialCode;
    }

    public void setMaterialCode(String materialCode) {
        this.materialCode = materialCode;
    }

    public String getMaterialName() {
        return materialName;
    }

    public void setMaterialName(String materialName) {
        this.materialName = materialName;
    }

    @Override
    public String toString() {
        return new ToStringBuilder(this, ToStringStyle.MULTI_LINE_STYLE)
                .append("productOutstockId", getProductOutstockId())
                .append("taskCode", getTaskCode())
                .append("warehouseId", getWarehouseId())
                .append("locationCode", getLocationCode())
                .append("operationType", getOperationType())
                .append("outstockType", getOutstockType())
                .append("planCode", getPlanCode())
                .append("planDetailCode", getPlanDetailCode())
                .append("applyReason", getApplyReason())
                .append("auditReason", getAuditReason())
                .append("auditStatus", getAuditStatus())
                .append("executeStatus", getExecuteStatus())
                .append("applyBy", getApplyBy())
                .append("applyDate", getApplyDate())
                .append("auditBy", getAuditBy())
                .append("auditDate", getAuditDate())
                .append("updateBy", getUpdateBy())
                .append("updateDate", getUpdateDate())
                .append("beginTime", getBeginTime())
                .append("endTime", getEndTime())
                .append("wmsProductOutstockDetailList", getWmsProductOutstockDetailList())
                .toString();
    }
}
